var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/github/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install,
  using: () => using
});
module.exports = __toCommonJS(src_exports);
var import_zhin3 = require("zhin");
var import_plugin_database = require("@zhinjs/plugin-database");

// packages/github/src/markdown.ts
var import_zhin = require("zhin");
var import_marked = require("marked");
function renderToken(token) {
  if (token.type === "code") {
    return token.text + "\n";
  } else if (token.type === "paragraph") {
    return render(token.tokens);
  } else if (token.type === "image") {
    return (0, import_zhin.Element)("image", { src: token.href }).toString();
  } else if (token.type === "blockquote") {
    return token.text;
  }
  return token.raw;
}
__name(renderToken, "renderToken");
function render(tokens) {
  return tokens.map(renderToken).join("");
}
__name(render, "render");
function transform(source) {
  if (!source)
    return "";
  source = source.replace(/^<!--(.*)-->$/gm, "");
  return render(import_marked.marked.lexer(source)).trim().replace(/\n\s*\n/g, "\n");
}
__name(transform, "transform");

// packages/github/src/events.ts
var defaultEvents = {
  commitComment: {
    created: true
  },
  issueComment: {
    created: true
  },
  issues: {
    closed: true,
    opened: true
  },
  milestone: {
    created: true
  },
  pullRequest: {
    closed: true,
    opened: true,
    reopened: true,
    readyForReview: true,
    convertedToDraft: true,
    reviewRequested: true
  },
  pullRequestReview: {
    submitted: true
  },
  pullRequestReviewComment: {
    created: true
  },
  star: {
    created: true
  }
};
function addListeners(on) {
  const createFactory = /* @__PURE__ */ __name((callback) => (event, handler) => {
    on(event, (payload) => Reflect.apply(callback, null, [event, payload, handler]));
  }, "createFactory");
  const onComment = createFactory((event, payload, handler) => {
    const { user, body, html_url, url } = payload.comment;
    if (user.type === "Bot")
      return;
    const [target, replies] = handler(payload);
    if (payload.action === "deleted") {
      return [`${user.login} deleted a comment on ${target}`];
    }
    const { padding } = replies;
    delete replies.padding;
    const index = html_url.indexOf("#");
    const operation = payload.action === "created" ? "commented" : "edited a comment";
    return [`${user.login} ${operation} on ${target}
${transform(body)}`, {
      link: [html_url],
      react: [url + `/reactions`],
      shot: [
        html_url.slice(0, index),
        html_url.slice(index),
        padding
      ],
      ...replies
    }];
  });
  onComment("commit_comment", ({ repository, comment }) => {
    const { full_name } = repository;
    const { commit_id, path, position } = comment;
    return [`commit ${full_name}@${commit_id.slice(0, 6)}
Path: ${path}`, {
      reply: [`https://api.github.com/repos/${full_name}/commits/${commit_id}/comments`, { path, position }]
    }];
  });
  const onReference = createFactory((event, { repository, ref, ref_type, sender }) => {
    const ref_name = `${repository.full_name}${ref_type === "tag" ? "@" : ":"}${ref}`;
    return [`${sender.login} ${event}d ${ref_type} ${ref_name}`];
  });
  onReference("create");
  onReference("delete");
  on("fork", ({ repository, sender, forkee }) => {
    const { full_name, forks_count } = repository;
    return [`${sender.login} forked ${full_name} to ${forkee.full_name} (total ${forks_count} forks)`];
  });
  onComment("issue_comment", ({ issue, repository }) => {
    const { full_name } = repository;
    const { number, comments_url } = issue;
    const type = issue["pull_request"] ? "pull request" : "issue";
    return [`${type} ${full_name}#${number}`, {
      reply: [comments_url],
      padding: [16, 16, 16, 88]
    }];
  });
  const onIssue = createFactory((event, payload, handler) => {
    const { user, url, html_url, comments_url } = payload.issue;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      close: [url, comments_url],
      link: [html_url],
      react: [url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onIssue("issues/opened", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, body, number } = issue;
    return [[
      `${sender.login} opened an issue ${full_name}#${number}`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")];
  });
  onIssue("issues/closed", ({ repository, issue, sender }) => {
    const { full_name } = repository;
    const { title, number } = issue;
    return [`${sender.login} closed issue ${full_name}#${number}
${title}`];
  });
  onComment("pull_request_review_comment", ({ repository, comment, pull_request }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    const { path, url } = comment;
    return [`pull request review ${full_name}#${number}
Path: ${path}`, {
      reply: [url]
    }];
  });
  on("milestone/created", ({ repository, milestone, sender }) => {
    const { full_name } = repository;
    const { title, description } = milestone;
    return [`${sender.login} created milestone ${title} for ${full_name}
${description}`];
  });
  on("pull_request_review/submitted", ({ repository, review, pull_request }) => {
    if (!review.body)
      return;
    const { full_name } = repository;
    const { number, comments_url } = pull_request;
    const { user, html_url, body } = review;
    if (user.type === "Bot")
      return;
    return [[
      `${user.login} reviewed pull request ${full_name}#${number}`,
      transform(body)
    ].join("\n"), {
      link: [html_url],
      reply: [comments_url]
    }];
  });
  const onPullRequest = createFactory((event, payload, handler) => {
    const { user, url, html_url, issue_url, comments_url } = payload.pull_request;
    if (user.type === "Bot")
      return;
    const [message, replies] = handler(payload);
    return [message, {
      base: [url],
      close: [issue_url, comments_url],
      link: [html_url],
      merge: [url + "/merge"],
      rebase: [url + "/merge"],
      squash: [url + "/merge"],
      react: [issue_url + `/reactions`],
      reply: [comments_url],
      ...replies
    }];
  });
  onPullRequest("pull_request/closed", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number, merged } = pull_request;
    const type = merged ? "merged" : "closed";
    return [`${sender.login} ${type} pull request ${full_name}#${number}
${title}`];
  });
  onPullRequest("pull_request/reopened", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { title, number } = pull_request;
    return [`${sender.login} reopened pull request ${full_name}#${number}
${title}`];
  });
  onPullRequest("pull_request/opened", ({ repository, pull_request, sender }) => {
    const { full_name, owner } = repository;
    const { title, base, head, body, number, draft } = pull_request;
    const prefix = new RegExp(`^${owner.login}:`);
    const baseLabel = base.label.replace(prefix, "");
    const headLabel = head.label.replace(prefix, "");
    return [[
      `${sender.login} ${draft ? "drafted" : "opened"} a pull request ${full_name}#${number} (${baseLabel} ← ${headLabel})`,
      `Title: ${title}`,
      transform(body)
    ].join("\n")];
  });
  onPullRequest("pull_request/review_requested", (payload) => {
    const { repository, pull_request, sender } = payload;
    const { full_name } = repository;
    const { number } = pull_request;
    return ["requested_reviewer" in payload ? `${sender.login} requested a review from ${payload.requested_reviewer.login} on ${full_name}#${number}` : `${sender.login} requested a review from team ${payload.requested_team.name} on ${full_name}#${number}`];
  });
  onPullRequest("pull_request/converted_to_draft", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return [`${sender.login} marked ${full_name}#${number} as draft`];
  });
  onPullRequest("pull_request/ready_for_review", ({ repository, pull_request, sender }) => {
    const { full_name } = repository;
    const { number } = pull_request;
    return [`${sender.login} marked ${full_name}#${number} as ready for review`];
  });
  on("push", ({ compare, pusher, sender, commits, repository, ref, before, after }) => {
    const { full_name } = repository;
    if (sender.type === "Bot")
      return;
    if (/^0+$/.test(before) || /^0+$/.test(after))
      return;
    return [[
      `${pusher.name} pushed to ${full_name}:${ref.replace(/^refs\/heads\//, "")}`,
      ...commits.map((c) => `[${c.id.slice(0, 6)}] ${transform(c.message)}`)
    ].join("\n"), {
      link: [compare]
    }];
  });
  on("star/created", ({ repository, sender }) => {
    const { full_name, stargazers_count } = repository;
    return [`${sender.login} starred ${full_name} (total ${stargazers_count} stargazers)`];
  });
}
__name(addListeners, "addListeners");

// packages/github/src/serve.ts
var import_zhin2 = require("zhin");
var import_sequelize2 = require("sequelize");

// packages/github/src/models/github.ts
var import_sequelize = require("sequelize");
var GithubTable;
((GithubTable2) => {
  GithubTable2.model = {
    name: import_sequelize.DataTypes.STRING,
    secret: import_sequelize.DataTypes.STRING
  };
})(GithubTable || (GithubTable = {}));

// packages/github/src/serve.ts
var GitHub = class {
  constructor(ctx, config) {
    this.ctx = ctx;
    this.config = config;
    this.history = /* @__PURE__ */ Object.create(null);
    this.http = ctx.request.extend({});
    if (ctx.database) {
      this.init();
    }
    ctx.disposes.push(this.ctx.app.on("database-created", () => {
      this.init();
    }));
  }
  init() {
    this.ctx.database.extend("User", {
      github_accessToken: import_sequelize2.DataTypes.STRING,
      github_refreshToken: import_sequelize2.DataTypes.STRING
    });
    this.ctx.database.extend("Group", {
      github_webhooks: {
        type: import_sequelize2.DataTypes.TEXT,
        get() {
          return JSON.parse(this.getDataValue("github_webhooks") || "{}");
        },
        set(value) {
          this.setDataValue("github_webhooks", JSON.stringify(value));
        }
      }
    });
    this.ctx.database.define("github", GithubTable.model);
  }
  async getTokens(params) {
    return this.http.post("https://github.com/login/oauth/access_token", {}, {
      params: {
        client_id: this.config.appId,
        client_secret: this.config.appSecret,
        ...params
      },
      headers: { Accept: "application/json" },
      timeout: this.config.requestTimeout
    });
  }
  async _request(method, url, replyMsg, data, headers) {
    this.ctx.logger.debug(method, url, data);
    return this.http(method, url, {
      data,
      headers: {
        accept: "application/vnd.github.v3+json",
        authorization: `token ${replyMsg.member.github_accessToken}`,
        ...headers
      },
      timeout: this.config.requestTimeout
    });
  }
  async authorize(session, message) {
    const name = await session.prompt.text(message);
    if (name) {
      await session.execute({ name: "github.authorize", session, elements: [], args: [name] });
    } else {
      await session.reply("输入超时");
    }
  }
  async request(method, url, session, body, headers) {
    var _a;
    if (session.detail_type !== "group")
      return "只能在群聊中使用";
    if (!session.member.github_accessToken) {
      return this.authorize(session, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    try {
      return await this._request(method, url, session, body, headers);
    } catch (error) {
      if (((_a = error.response) == null ? void 0 : _a.status) !== 401)
        throw error;
    }
    try {
      const data = await this.getTokens({
        refresh_token: session.member.github_refreshToken,
        grant_type: "refresh_token"
      });
      session.member.github_accessToken = data.access_token;
      session.member.github_refreshToken = data.refresh_token;
    } catch {
      return this.authorize(session, "令牌已失效，需要重新授权。输入你的 GitHub 用户名。");
    }
    return await this._request(method, url, session, body, headers);
  }
};
__name(GitHub, "GitHub");
var Config = import_zhin2.Schema.object({
  path: import_zhin2.Schema.string().description("webhook路径").default("/github"),
  appId: import_zhin2.Schema.string().description("Github AppId").required(true),
  appSecret: import_zhin2.Schema.string().description("Github AppSecret").required(true),
  messagePrefix: import_zhin2.Schema.string().description("消息前缀"),
  redirect: import_zhin2.Schema.string().description("请求回调地址").default("/redirect"),
  promptTimeout: import_zhin2.Schema.number().description("会话超时时间").default(6e4),
  replyTimeout: import_zhin2.Schema.number().description("回复超时时间").default(6e4),
  requestTimeout: import_zhin2.Schema.number().description("请求超时时间").default(6e4)
});
var ReplyHandler = class {
  constructor(github, ctxEvent, content) {
    this.github = github;
    this.ctxEvent = ctxEvent;
    this.content = content;
  }
  async request(method, url, message, body, headers) {
    try {
      await this.github.request(method, url, this.ctxEvent, body, headers);
    } catch (err) {
      return message;
    }
  }
  link(url) {
    return url;
  }
  react(url) {
    return this.request("POST", url, "发送失败", {
      content: this.content
    }, {
      accept: "application/vnd.github.squirrel-girl-preview"
    });
  }
  async transform(source) {
    const [{ type, attrs: { url, text } }] = import_zhin2.h.parse(source);
    return type !== "image" ? text : `![${text}](${url})`;
  }
  async reply(url, params) {
    return this.request("POST", url, "发送失败", {
      body: await this.transform(this.content),
      ...params
    });
  }
  base(url) {
    return this.request("PATCH", url, "修改失败", {
      base: this.content
    });
  }
  merge(url, method) {
    const [title] = this.content.split("\n", 1);
    const message = this.content.slice(title.length);
    return this.request("PUT", url, "操作失败。", {
      merge_method: method,
      commit_title: title.trim(),
      commit_message: message.trim()
    });
  }
  rebase(url) {
    return this.merge(url, "rebase");
  }
  squash(url) {
    return this.merge(url, "squash");
  }
  async close(url, commentUrl) {
    if (this.content)
      await this.reply(commentUrl);
    await this.request("PATCH", url, "操作失败", {
      state: "closed"
    });
  }
};
__name(ReplyHandler, "ReplyHandler");

// packages/github/src/index.ts
var import_querystring = require("querystring");
var import_crypto = require("crypto");
var using = ["database"];
function install(ctx) {
  ctx.middleware(async (session, next) => {
    await next();
    const mathReg = /^(?:https?:\/\/)?(?:www\.)?github\.com\/([^/]+)\/([^/]+)\/?$/;
    const match = session.elements.join("").match(mathReg);
    if (!match)
      return;
    const [, owner, repo] = match;
    const src = `https://opengraph.github.com/repo/${owner}/${repo}`;
    session.reply((0, import_zhin3.h)("image", { src }));
  });
  const config = Config((0, import_zhin3.useOptions)("services.github"));
  if (!config)
    return;
  config.path = (0, import_zhin3.sanitize)(config.path);
  const { database } = ctx;
  const { appId, redirect } = config;
  const subscriptions = {};
  ctx.service("github", GitHub, config);
  const tokens = /* @__PURE__ */ Object.create(null);
  ctx.router.get(config.path + "/authorize", async (_ctx) => {
    const token = _ctx.query.state;
    if (!token || Array.isArray(token))
      return _ctx.status = 400;
    const user_id = tokens[token];
    if (!user_id)
      return _ctx.status = 403;
    delete tokens[token];
    const { code, state } = _ctx.query;
    const data = await ctx.github.getTokens({ code, state, redirect_uri: redirect });
    if (ctx.database.isReady) {
      await database.model("User").update({
        github_accessToken: data.access_token,
        github_refreshToken: data.refresh_token
      }, { where: { user_id } });
    } else {
      ctx.disposes.push(
        ctx.app.on("database-ready", async () => {
          await database.model("User").update({
            github_accessToken: data.access_token,
            github_refreshToken: data.refresh_token
          }, { where: { user_id } });
        })
      );
    }
    return _ctx.status = 200;
  });
  ctx.command("github [name:string]", "group").desc("github仓库管理指令").alias("gh").auth("master", "admins").option("list", "-l").option("add", "-a").option("delete", "-d").action(async ({ session, options }, name) => {
    if (options.list) {
      const names = Object.keys(session.group.github_webhooks || {});
      if (!names.length)
        return "当前没有监听仓库";
      return names.sort().join("\n");
    }
    if (options.add || options.delete) {
      if (!name)
        return "请输入仓库名";
      if (!repoRegExp.test(name))
        return "仓库名无效";
      name = name.toLowerCase();
      const github_webhooks = session.group.github_webhooks;
      if (options.add) {
        if (github_webhooks[name])
          return "已添加过仓库 " + name;
        const [repo] = await ctx.database.get("github", { name: [name] });
        if (!repo) {
          const dispose = ctx.middleware((session2, next) => {
            dispose();
            const cqCode = session2.elements.join("");
            if (cqCode && cqCode !== "." && cqCode !== "。")
              return next();
            return session.execute({
              name: "github.repos",
              session,
              elements: [],
              args: [name],
              options: { add: true, subscribe: true }
            });
          });
          return `尚未添加过仓库 ${name}。发送空行或句号以立即添加并订阅该仓库`;
        }
        github_webhooks[name] = (0, import_zhin3.deepClone)(defaultEvents);
        await ctx.database.set("Group", { group_id: session.group_id }, { github_webhooks });
        subscribe(name, session.group_id, github_webhooks[name]);
        return "添加成功";
      } else if (options.delete) {
        if (!github_webhooks[name])
          return "尚未在当前群聊订阅过仓库" + name;
        delete github_webhooks[name];
        await ctx.database.set("Group", { group_id: session.group_id }, { github_webhooks });
        unsubscribe(name, session.group_id);
        return "删除成功";
      }
    }
    return session.execute({ session, name: "help", elements: [], args: ["github"] });
  });
  ctx.command("github/github.authorize <user:string>", "group").alias("github.auth").action(async ({ session }, user) => {
    if (!user)
      return "请输入用户名";
    const token = import_zhin3.Random.id();
    tokens[token] = session.user_id;
    const url = "https://github.com/login/oauth/authorize?" + (0, import_querystring.encode)({
      client_id: appId,
      state: token,
      redirect_uri: redirect,
      scope: "admin:repo_hook,repo",
      login: user
    });
    return "点击下面的链接继续操作：\n" + url;
  });
  const repoRegExp = /^[\w.-]+\/[\w.-]+$/;
  ctx.command("github/github.repos [name:string]", "group").option("add", "-a").option("delete", "-d").option("subscribe", "-s").action(async ({ session, options }, name) => {
    if (options.add || options.delete) {
      if (!name)
        return "请输入仓库名";
      if (!repoRegExp.test(name))
        return "仓库名无效";
      if (!session.member.github_accessToken) {
        return ctx.github.authorize(session, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
      }
      name = name.toLowerCase();
      const url = `https://api.github.com/repos/${name}/hooks`;
      const [repo] = await ctx.database.get("github", { name: [name] });
      if (options.add) {
        if (repo)
          return "重复添加";
        const secret = import_zhin3.Random.id();
        let data;
        try {
          data = await ctx.github.request("POST", url, session, {
            events: ["*"],
            config: {
              secret,
              url: ctx.app.options.self_url + config.path + "/webhook"
            }
          });
        } catch (err) {
          if (!err.response)
            throw err;
          if (err.response.status === 404) {
            return "未找到仓库 " + name;
          } else if (err.response.status === 403) {
            return "访问受限";
          } else {
            ctx.logger.warn(err);
            return "添加失败";
          }
        }
        await ctx.database.add("github", { name, id: data.id, secret });
        if (!options.subscribe)
          return "添加成功";
        return session.execute({
          name: "github",
          session,
          elements: [],
          args: [name],
          options: { add: true }
        });
      } else {
        if (!repo)
          return "删除失败";
        try {
          await ctx.github.request("DELETE", `${url}/${repo.toJSON().id}`, session);
        } catch (err) {
          if (!err.response)
            throw err;
          if (err.response.status !== 404) {
            ctx.logger.warn(err);
            return "删除失败";
          }
        }
        async function updateChannels() {
          const groups = await ctx.database.get("Group");
          for (const group of groups) {
            const { github_webhooks } = group.toJSON();
            if (!github_webhooks)
              continue;
            const shouldUpdate = github_webhooks[name];
            delete github_webhooks[name];
            if (shouldUpdate) {
              await group.update({ github_webhooks });
            }
          }
        }
        __name(updateChannels, "updateChannels");
        unsubscribe(name);
        await Promise.all([
          updateChannels(),
          ctx.database.delete("github", { name: [name] })
        ]);
        return "删除成功";
      }
    }
    const repos = await ctx.database.get("github", {});
    if (!repos.length)
      return "当前没有监听的仓库";
    return repos.map((repo) => repo.toJSON().name).join("\n");
  });
  function subscribe(repo, group_id, meta) {
    (subscriptions[repo] || (subscriptions[repo] = {}))[group_id] = meta;
  }
  __name(subscribe, "subscribe");
  function unsubscribe(repo, group_id) {
    if (!group_id)
      return delete subscriptions[repo];
    delete subscriptions[repo][group_id];
    if (!Object.keys(subscriptions[repo]).length) {
      delete subscriptions[repo];
    }
  }
  __name(unsubscribe, "unsubscribe");
  async function request(method, url, session, body, message) {
    return ctx.github.request(method, "https://api.github.com" + url, session, body).then(() => message + "成功").catch((err) => {
      ctx.logger.warn(err);
      return message + "失败";
    });
  }
  __name(request, "request");
  ctx.command("github/github.issue [title] [body:text]", "group").option("repo", "-r [repo:string]").action(async ({ session, options }, title, body) => {
    if (!options.repo)
      return "请输入仓库名";
    if (!repoRegExp.test(options.repo))
      return "仓库名无效";
    if (!session.member.github_accessToken) {
      return ctx.github.authorize(session, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    return request("POST", `/repos/${options.repo}/issues`, session, {
      title,
      body
    }, "创建");
  });
  ctx.command("github/github.star [repo]", "group").option("repo", "-r [repo:string]").action(async ({ session, options }) => {
    if (!options.repo)
      return "请输入仓库名";
    if (!repoRegExp.test(options.repo))
      return "仓库名无效";
    if (!session.member.github_accessToken) {
      return ctx.github.authorize(session, "要使用此功能，请对机器人进行授权。输入你的 GitHub 用户名。");
    }
    return request("PUT", `/user/starred/${options.repo}`, session, null, "操作");
  });
  ctx.disposes.push(ctx.on("database-ready", async () => {
    const channels = await ctx.database.get("Group");
    for (const channel of channels) {
      const { github_webhooks, group_id } = channel.toJSON();
      if (!github_webhooks)
        continue;
      for (const repo in github_webhooks) {
        subscribe(repo, group_id, github_webhooks[repo]);
      }
    }
  }));
  const reactions = ["+1", "-1", "laugh", "confused", "heart", "hooray", "rocket", "eyes"];
  function safeParse(source) {
    try {
      return JSON.parse(source);
    } catch {
    }
  }
  __name(safeParse, "safeParse");
  ctx.router.post(config.path + "/webhook", async (_ctx) => {
    const event = _ctx.headers["x-github-event"];
    const signature = _ctx.headers["x-hub-signature-256"];
    const id = _ctx.headers["x-github-delivery"];
    const webhookId = +_ctx.headers["x-github-hook-id"];
    const payload = safeParse(_ctx.request.body.payload);
    if (!payload)
      return _ctx.status = 400;
    const fullEvent = payload.action ? `${event}/${payload.action}` : event;
    ctx.logger.debug("received %s (%s)", fullEvent, id);
    const [data] = await database.get("github", { id: webhookId });
    if (!data)
      return _ctx.status = 202;
    if (signature !== `sha256=${(0, import_crypto.createHmac)("sha256", data.toJSON().secret).update(_ctx.request.rawBody).digest("hex")}`) {
      return _ctx.status = 403;
    }
    const fullName = payload.repository.full_name.toLowerCase();
    if (data.toJSON().name !== fullName) {
      await database.set("github", { id: webhookId }, { name: fullName, secret: data.toJSON().secret });
      unsubscribe(data.toJSON().name);
      const groups = await ctx.database.get("Group");
      for (const group of groups) {
        const { github_webhooks, group_id } = group.toJSON();
        if (!github_webhooks)
          continue;
        const shouldUpdate = github_webhooks[data.toJSON().name];
        if (shouldUpdate) {
          github_webhooks[fullName] = shouldUpdate;
          subscribe(fullName, group_id, github_webhooks[fullName]);
          delete github_webhooks[data.toJSON().name];
          await group.update({ github_webhooks });
        }
      }
    }
    _ctx.status = 200;
    if (payload.action) {
      ctx.emit(`github/${fullEvent}`, payload);
    }
    ctx.emit(`github/${event}`, payload);
  });
  ctx.middleware((session, next) => {
    if (!session.quote || session.detail_type !== "group")
      return next();
    const body = session.quote.element.join("");
    const payloads = ctx.github.history[session.quote.message_id];
    if (!body || !payloads)
      return next();
    let name, message;
    name = reactions.includes(body) ? "react" : "reply";
    message = body;
    const payload = payloads[name];
    if (!payload)
      return next();
    const handler = new ReplyHandler(ctx.github, session, message);
    return handler[name](...payload);
  });
  addListeners((event, handler) => {
    const base = (0, import_zhin3.camelize)(event.split("/", 1)[0]);
    ctx.on(`github/${event}`, async (payload) => {
      const repoConfig = subscriptions[payload.repository.full_name.toLowerCase()] || {};
      const targets = Object.keys(repoConfig).filter((id) => {
        const baseConfig = repoConfig[id][base] || (0, import_zhin3.deepClone)(defaultEvents);
        if (baseConfig === false)
          return;
        if (payload.action && baseConfig !== true) {
          const action = (0, import_zhin3.camelize)(payload.action);
          const actionConfig = baseConfig[action];
          if (actionConfig === false)
            return;
          if (actionConfig !== true && !(defaultEvents[base] || {})[action])
            return;
        }
        return true;
      });
      if (!targets.length)
        return;
      const result = handler(payload);
      if (!result)
        return;
      ctx.logger.info("broadcast", result[0]);
      const messageIds = await ctx.broadcast(`group:${targets}`, (config.messagePrefix || "[GitHub]") + result[0]);
      for (const { message_id } of messageIds) {
        ctx.github.history[message_id] = result[1];
      }
      ctx.setTimeout(() => {
        for (const { message_id } of messageIds) {
          delete ctx.github.history[message_id];
        }
      }, config.replyTimeout);
    });
  });
}
__name(install, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  using
});
//# sourceMappingURL=index.js.map
